// Http.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef HTTP_H
#define HTTP_H
///////////////////////////////////////////////////////////
#include <winsock.h>
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
bool DownloadFile( char *servername, char *filepath, char *filename ) {
	// Initialize the WinSock library:
	WSADATA wsaData;
	int wsaret = WSAStartup( 0x101, &wsaData );
	if( wsaret ) {
		return(false);
	}

	// Create a socket:
	SOCKET conn;
	conn = socket( AF_INET, SOCK_STREAM, IPPROTO_TCP );
	if( conn == INVALID_SOCKET ) {
		fwprintf(g_flogu,L"Socket did not connect.\n");
		return(false);
	}


	// Get the host information:
	hostent *hp;
	if( inet_addr(servername) == INADDR_NONE ) {
		hp = gethostbyname(servername);
	} else {
		unsigned long addr = inet_addr(servername);
		hp = gethostbyaddr((char*)&addr,sizeof(addr),AF_INET);
	}

	if( hp == NULL ) {
		fwprintf(g_flogu,L"Invalid host.\n");
		closesocket(conn);
		return(false);
	}




	sockaddr_in server;
		server.sin_addr.s_addr = *((unsigned long*)hp->h_addr);
		server.sin_family = AF_INET;
		server.sin_port = htons(80);
	if( connect(conn,(struct sockaddr*)&server,sizeof(server)) ) {
		closesocket(conn);
		fwprintf(g_flogu,L"Connect failed.\n");
		return(false);
	}





	// Send it the GET command:
	char buff[1024];
	//sprintf(buff,"GET %s\r\n\r\n",filepath );
	sprintf(buff,"GET http://%s/%s\r\n",servername,filepath );
	int result = send( conn, buff, strlen(buff), 0 );
	if( result == 0 || result == SOCKET_ERROR ) {
		closesocket(conn);
		fwprintf(g_flogu,L"Send failed.\n");
		return(false);
	}

	//Uint16 str[1024]; swprintf(str,L"%S",buff);	MessageBox(NULL,str,L"Sent",MB_OK );



	FILE *f = fopen( filename, "wb" );
	if( !f ) {
		//MessageBox(NULL,L"Cannot open file",L"Error",MB_OK );

		closesocket(conn);
		WSACleanup();
		return(false);
	} else {

		char tiny[256];

		int received = 0;
		while( true ) {
			//MessageBox(NULL,L"ABOUT to receive...",L"!",MB_OK );
			received = recv( conn, tiny, 256, 0 );
			if( received == 0 ) {
				fwprintf(g_flogu,L"File received okay.\n");
				//MessageBox(NULL,L"File received okay.",L"!",MB_OK );
				break;
			} else if( received == SOCKET_ERROR ) {
				fwprintf(g_flogu,L"Receive error.\n");
				//MessageBox(NULL,L"Receive error.",L"!",MB_OK );
				fclose(f);
				closesocket(conn);
				WSACleanup();
				return(false);
			} else {
				//MessageBox(NULL,L"Received data",L"!",MB_OK );
				fwrite( tiny,sizeof(char),received, f );
			}
		}
		fclose(f);

		closesocket(conn);
		WSACleanup();
		return(true);
	}
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
