// Search_Rebar.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef SEARCH_REBAR_H
#define SEARCH_REBAR_H
///////////////////////////////////////////////////////////
struct Encoding {
	int combobox_index;
	TCHAR *combobox_string;
	char *iconv_string;
};
//EUC-JP, SHIFT_JIS, CP932, ISO-2022-JP, ISO-2022-JP-2, ISO-2022-JP-1
Encoding encoding_array[] = {
	{ 0, TEXT("<<Windows Unicode>>"), NULL },
	{ 0, TEXT("Normal Unicode (Windows)"), "UTF-16LE" },
	{ 0, TEXT("<<Unicode>>"), NULL },
	{ 0, TEXT("UTF-8"), "UTF-8" },
	{ 0, TEXT("UCS-2"), "UCS-2" },
	{ 0, TEXT("UCS-2BE"), "UCS-2BE" },
	{ 0, TEXT("UCS-2LE"), "UCS-2LE" },
	{ 0, TEXT("UCS-4"), "UCS-4" },
	{ 0, TEXT("UCS-4BE"), "UCS-4BE" },
	{ 0, TEXT("UCS-4LE"), "UCS-4LE" },
	{ 0, TEXT("UTF-16"), "UTF-16" },
	{ 0, TEXT("UTF-16BE"), "UTF-16BE" },
	{ 0, TEXT("UTF-16LE"), "UTF-16LE" },
	{ 0, TEXT("UTF-32"), "UTF-32" },
	{ 0, TEXT("UTF-32BE"), "UTF-32BE" },
	{ 0, TEXT("UTF-32LE"), "UTF-32LE" },
	{ 0, TEXT("UTF-7"), "UTF-7" },
	{ 0, TEXT("C99"), "C99" },
	{ 0, TEXT("JAVA"), "JAVA" },
	{ 0, TEXT("<<Japanese>>"), NULL },
	{ 0, TEXT("EUC-JP"), "EUC-JP" },
	{ 0, TEXT("Shift JIS (SJIS)"), "SHIFT_JIS" },
	{ 0, TEXT("CP932 (Microsoft SJIS)"), "CP932" },
	{ 0, TEXT("ISO-2022-JP (~1983)"), "ISO-2022-JP" },
	{ 0, TEXT("ISO-2022-JP-1 (~1990)"), "ISO-2022-JP-1" },
	{ 0, TEXT("ISO-2022-JP-2 (Multi-lingual extention)"), "ISO-2022-JP-2" },
	{ 0, TEXT("<<Chinese>>"), NULL },
	{ 0, TEXT("EUC-CN"), "EUC-CN" },
	{ 0, TEXT("HZ"), "HZ" },
	{ 0, TEXT("GBK"), "GBK" },
	{ 0, TEXT("GB18030"), "GB18030" },
	{ 0, TEXT("EUC-TW"), "EUC-TW" },
	{ 0, TEXT("BIG5"), "BIG5" },
	{ 0, TEXT("CP950"), "CP950" },
	{ 0, TEXT("BIG5-HKSCS"), "BIG5-HKSCS" },
	{ 0, TEXT("ISO-2022-CN"), "ISO-2022-CN" },
	{ 0, TEXT("ISO-2022-CN-EXT"), "ISO-2022-CN-EXT" },
	/* These aren't supported:
	{ 0, TEXT("EUC-JISX0213"), "EUC-JISX0213" },
	{ 0, TEXT("Shift_JISX0213"), "Shift_JISX0213" },
	{ 0, TEXT("ISO-2022-JP-3"), "ISO-2022-JP-3" },//*/
};
int encoding_array_size = sizeof(encoding_array)/sizeof(Encoding);
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
void AddTextToReBar( HWND hwndRB, wstring str ) {
   REBARBANDINFO rbBand;
		rbBand.cbSize = sizeof(REBARBANDINFO);  // Required
		rbBand.fMask  = RBBIM_STYLE |
							 RBBIM_TEXT;// | RBBIM_SIZE;
	   rbBand.fStyle = RBBS_NOGRIPPER;
   // Set values unique to the band with the toolbar.
		rbBand.lpText     = (Uint16*)str.c_str();

		//rbBand.cx = 40;
   SendMessage( hwndRB, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbBand );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateSearch_Rebar( HWND hwndParent ) {
   HWND hwndRB = CreateWindowEx(
									WS_EX_TOOLWINDOW,
                           REBARCLASSNAME,
                           NULL,
                           WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|
                           WS_CLIPCHILDREN|/*RBS_VARHEIGHT|*/CCS_NODIVIDER|
									RBS_BANDBORDERS | RBS_AUTOSIZE,
                           0,0,
									0,0,
                           hwndParent,
                           (HMENU)WID_SEARCH_REBAR,
                           g_hinst,
                           NULL);

   // Initialize and send the REBARINFO structure.
	REBARINFO rbi;
	   rbi.cbSize = sizeof(REBARINFO);  // Required when using this structure.
		rbi.fMask  = 0;
		rbi.himl   = (HIMAGELIST)NULL;
   if( !SendMessage(hwndRB, RB_SETBARINFO, 0, (LPARAM)&rbi) ) {
		fwprintf(g_flogu,L"WTF ERROR!\n");
		fwprintf(g_flogu,L"END CreateSearch_Rebar()\n");
      return NULL;
	}

	// Set the text color to black.
	SendMessage( hwndRB, RB_SETTEXTCOLOR, 0, (LPARAM)0x00000000 );
	// Set the background color to the menu color.
	SendMessage( hwndRB, RB_SETBKCOLOR, 0, (LPARAM)GetSysColor(COLOR_MENU) );



	AddTextToReBar( hwndRB, L"\0" );
	//AddTextToReBar( hwndRB, L"WTF\0" );
	//AddTextToReBar( hwndRB, L"Grrrrrrr\0" );
	//AddTextToReBar( hwndRB, L"Why me? I asked.\0" );
	//AddTextToReBar( hwndRB, L"Microsoft sucks big time...\0" );


//*
	///////////////////////
	///   SEARCH TYPE   ///
	///////////////////////
	{
	// Create the toolbar control to be added.
   HWND hwndTB = CreateSearch_Toolbar_SearchType( hwndRB );
	hwnd_searchrebar_toolbar_location = hwndTB;
		// Get the size of the toolbar:
		SIZE size;
			SendMessage( hwndTB, TB_GETMAXSIZE, 0, (LPARAM)&size );

	REBARBANDINFO rbBand;
		rbBand.cbSize = sizeof(REBARBANDINFO);  // Required
		rbBand.fMask  = RBBIM_TEXT |
							 RBBIM_STYLE |
			             RBBIM_CHILD | RBBIM_CHILDSIZE |
				          RBBIM_SIZE;
	   rbBand.fStyle = RBBS_CHILDEDGE|RBBS_NOGRIPPER;//|RBBS_VARIABLEHEIGHT|RBBS_USECHEVRON;//RBBS_GRIPPERALWAYS;//|RBBS_BREAK;//| RBBS_FIXEDBMP;
   // Set values unique to the band with the toolbar.
		rbBand.lpText = L"Search Type\0";

		rbBand.hwndChild  = hwndTB;
		
		rbBand.cxMinChild = size.cx;
		rbBand.cyMinChild = size.cy;
		//rbBand.cyChild    = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		//rbBand.cyMaxChild = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		//rbBand.cyIntegral = 1; // used with RBBS_VARIABLEHEIGHT.

		rbBand.cx         = rbBand.cxMinChild;

   // Add the band that has the toolbar.
   int result = SendMessage(hwndRB, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbBand);
	}//*/

//*
	///////////////////////////
	///   STRINGS TOOLBAR   ///
	///////////////////////////
	{
	// Create the toolbar control to be added.
   HWND hwndTB = CreateSearch_Toolbar_Strings( hwndRB );
	hwnd_searchrebar_toolbar_strings = hwndTB;
		// Get the size of the toolbar:
		SIZE size;
			SendMessage( hwndTB, TB_GETMAXSIZE, 0, (LPARAM)&size );

	REBARBANDINFO rbBand;
		rbBand.cbSize = sizeof(REBARBANDINFO);  // Required
		rbBand.fMask  = RBBIM_STYLE |
			             RBBIM_CHILD  | RBBIM_CHILDSIZE |
				          RBBIM_SIZE;
	   rbBand.fStyle = RBBS_CHILDEDGE|RBBS_NOGRIPPER;//|RBBS_VARIABLEHEIGHT|RBBS_USECHEVRON;//RBBS_GRIPPERALWAYS;//|RBBS_BREAK;//| RBBS_FIXEDBMP;
   // Set values unique to the band with the toolbar.
		rbBand.hwndChild  = hwndTB;
		
		rbBand.cxMinChild = size.cx;
		rbBand.cyMinChild = size.cy;
		//rbBand.cyChild    = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		//rbBand.cyMaxChild = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		//rbBand.cyIntegral = 1; // used with RBBS_VARIABLEHEIGHT.
		
		rbBand.cx         = rbBand.cxMinChild;

   // Add the band that has the toolbar.
   int result = SendMessage(hwndRB, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbBand);
	}//*/


/*
	AddTextToReBar( hwndRB, L"WTF\0" );
	AddTextToReBar( hwndRB, L"Grrrrrrr\0" );
	AddTextToReBar( hwndRB, L"Why me? I asked.\0" );
	AddTextToReBar( hwndRB, L"Microsoft sucks big time...\0" );

	AddTextToReBar( hwndRB, L"X\0" );
	AddTextToReBar( hwndRB, L"Huh?\0" );
	AddTextToReBar( hwndRB, L"futari dake\0" );
*/


//*
	{
	//////////////////////
	///   CONVERSION   ///
	//////////////////////
   HWND hwndTB = CreateSearch_Toolbar_Conversion( hwndRB );
	hwnd_searchrebar_toolbar_conversion = hwndTB;
		// Get the size of the toolbar:
		SIZE size;
			SendMessage( hwndTB, TB_GETMAXSIZE, 0, (LPARAM)&size );

	REBARBANDINFO rbBand;
		rbBand.cbSize = sizeof(REBARBANDINFO);  // Required
		rbBand.fMask  = RBBIM_TEXT |
			             RBBIM_STYLE | RBBIM_CHILD  | RBBIM_CHILDSIZE |
				          RBBIM_SIZE;
	   rbBand.fStyle = RBBS_CHILDEDGE|RBBS_NOGRIPPER;//|RBBS_VARIABLEHEIGHT|RBBS_USECHEVRON;//RBBS_GRIPPERALWAYS;//|RBBS_BREAK;//| RBBS_FIXEDBMP;
   // Set values unique to the band with the toolbar.
	   rbBand.lpText     = TEXT("Conversion");
				
		rbBand.hwndChild  = hwndTB;
		
		rbBand.cxMinChild = size.cx;
		rbBand.cyMinChild = size.cy;
		//rbBand.cyChild    = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		//rbBand.cyMaxChild = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		//rbBand.cyIntegral = 1; // used with RBBS_VARIABLEHEIGHT.
		
		rbBand.cx         = size.cx;

   // Add the band that has the toolbar.
   int result = SendMessage( hwndRB, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbBand );
	}//*/



//*
	{
	////////////////////
	///   COMBOBOX   ///
	////////////////////
	// Create the toolbar control to be added.
#ifdef VERSION_NT
		HWND hwndTB = CreateWindowEx(
			CBES_EX_NOSIZELIMIT,//0,
			WC_COMBOBOXEX,      // predefined class 
         NULL,        // no window title 
         //WS_CHILD | WS_VISIBLE | //CCS_NOPARENTALIGN | CCS_NOMOVEY | CCS_NODIVIDER | CCS_NORESIZE |
			WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_VSCROLL |
			WS_CLIPCHILDREN | WS_CLIPSIBLINGS | CBS_AUTOHSCROLL |
         CBS_DROPDOWNLIST | CBS_SIMPLE,
         0,0,
			100,300,
         hwndParent,        // parent window 
         (HMENU)WID_SEARCH_COMBOBOX,   // edit control ID 
         (HINSTANCE)g_hinst, 
         NULL       // pointer not needed 
		);
#else
		HWND hwndTB = CreateWindowEx(
			0,
			L"COMBOBOX",
         NULL, // no window title 
         //WS_CHILD | WS_VISIBLE | //CCS_NOPARENTALIGN | CCS_NOMOVEY | CCS_NODIVIDER | CCS_NORESIZE |
			WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_VSCROLL |
			WS_CLIPCHILDREN | WS_CLIPSIBLINGS |
			CBS_AUTOHSCROLL | CBS_DROPDOWNLIST | CBS_SIMPLE,
         0,0,
			100,300,
         hwndParent, // parent window 
         (HMENU)WID_SEARCH_COMBOBOX, // edit control ID 
         (HINSTANCE)g_hinst, 
         NULL // pointer not needed 
		);//*/
		SendMessage(hwndTB,CBEM_SETUNICODEFORMAT,TRUE,0 );
#endif

		hwnd_searchrebar_combobox_encode = hwndTB;
		// Make the width of the drop-down box bigger:
		SendMessage( hwndTB, CB_SETDROPPEDWIDTH, (WPARAM)250, 0 );

#ifdef VERSION_NT
		for( int i = 0; i < encoding_array_size; i++ ) {
			COMBOBOXEXITEM item;
				item.mask = CBEIF_TEXT;
				item.iItem = i;
				item.pszText = encoding_array[i].combobox_string;
				item.cchTextMax = wcslen(item.pszText);
			encoding_array[i].combobox_index = SendMessage( hwndTB, CBEM_INSERTITEM, 0, (LPARAM)&item );
		}
#else
		for( int i = 0; i < encoding_array_size; i++ ) {
			encoding_array[i].combobox_index = i;
			SendMessage( hwndTB, CB_ADDSTRING, 0, (LPARAM)encoding_array[i].combobox_string );
		}
		HFONT fntarial = CreateFont(14, 0,0,0,0,0,0,0,0,0,0,0,0,L"Arial" );
		SendMessage( hwndTB, WM_SETFONT, (WPARAM)fntarial, (LPARAM)TRUE );
#endif
		SendMessage( hwndTB, CB_SETCURSEL, (WPARAM)1, 0 );



	// Get the size of the toolbar:
		RECT rc;
			GetWindowRect( hwndTB, &rc );

	REBARBANDINFO rbBand;
		rbBand.cbSize = sizeof(REBARBANDINFO);  // Required
		rbBand.fMask  = //RBBIM_TEXT |
			             RBBIM_STYLE | RBBIM_CHILD  | RBBIM_CHILDSIZE |
				          RBBIM_SIZE;
	   rbBand.fStyle = RBBS_CHILDEDGE|RBBS_NOGRIPPER;//|RBBS_VARIABLEHEIGHT|RBBS_USECHEVRON;//RBBS_GRIPPERALWAYS;//|RBBS_BREAK;//| RBBS_FIXEDBMP;
		//rbBand.hbmBack = LoadBitmap(g_hinst,MAKEINTRESOURCE(IDB_BACKGRND));  
   // Set values unique to the band with the toolbar.
	   //rbBand.lpText     = TEXT("Conversion");
				
		rbBand.hwndChild  = hwndTB;
		
		rbBand.cxMinChild = rc.right-rc.left;
		rbBand.cyMinChild = rc.bottom-rc.top;
		//rbBand.cyChild    = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		//rbBand.cyMaxChild = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		//rbBand.cyIntegral = 1; // used with RBBS_VARIABLEHEIGHT.
		
		rbBand.cx         = rbBand.cxMinChild;

   // Add the band that has the toolbar.
   int result = SendMessage( hwndRB, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbBand );
	}//*/


/*
	//////////////////////////////////////////////////////////
	///   THIS IS THE BUTTON NEXT TO THE ENCODING BUTTON   ///
	//////////////////////////////////////////////////////////
	{
	//fprintf(g_flog,"TOOLBAR: ENCODE GO\n");
	// Create the toolbar control to be added.
   HWND hwndTB = CreateSearch_Toolbar_EncodeGo( hwndParent );//hwndRB);
		// Get the size of the toolbar:
		SIZE size;
			SendMessage( hwndTB, TB_GETMAXSIZE, 0, (LPARAM)&size );
		//fprintf(g_flog,"   rcToolbar(w): %i\n",size.cx );
		//fprintf(g_flog,"   rcToolbar(h): %i\n",size.cy );

	REBARBANDINFO rbBand;
		rbBand.cbSize = sizeof(REBARBANDINFO);  // Required
		rbBand.fMask  = RBBIM_COLORS |
			             RBBIM_STYLE | RBBIM_CHILD  | RBBIM_CHILDSIZE |
				          RBBIM_SIZE;
	   rbBand.fStyle = RBBS_CHILDEDGE|RBBS_NOGRIPPER;
   // Set values unique to the band with the toolbar.
		rbBand.clrFore    = 0;
		rbBand.clrBack    = GetSysColor(COLOR_MENU);//RGB(0,0,255);
				
		rbBand.hwndChild  = hwndTB;
		
		rbBand.cxMinChild = size.cx;
		rbBand.cyMinChild = size.cy;
		rbBand.cyChild    = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		rbBand.cyMaxChild = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		rbBand.cyIntegral = 1; // used with RBBS_VARIABLEHEIGHT.
		
		rbBand.cx         = size.cx;

   // Add the band that has the toolbar.
   int result = SendMessage( hwndRB, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbBand );
	//fprintf(g_flog,"   result: %s\n",result!=0?"okay":"><");
		hwnd_searchrebar_toolbar_encodego = hwndTB;
	}//*/











//*
	///////////////////////////////////////
	///   THE RESULT-MAX EDIT CONTROL   ///
	///////////////////////////////////////
	{
	// Create the toolbar control to be added.
	HWND hwndTB = CreateWindow(
		TEXT("EDIT"),      // predefined class 
      NULL,        // no window title 
		WS_CHILD | WS_VISIBLE | //CCS_NOPARENTALIGN | CCS_NOMOVEY | CCS_NODIVIDER | CCS_NORESIZE |
		ES_CENTER | ES_NUMBER | ES_LEFT | WS_BORDER, //| ES_MULTILINE | ES_AUTOVSCROLL, 
		0,0,
		30,18,
		hwndParent, // parent window 
		(HMENU)WID_SEARCH_RESULTSMAX, // edit control ID 
		(HINSTANCE)g_hinst, 
		NULL // pointer not needed
	);

	hwnd_searchrebar_edit_resultsize = hwndTB;
	
	SendMessage( hwndTB, WM_SETFONT, (WPARAM)hfont_msgothic12, 0 );			
	Uint16 str[100]; swprintf( str, L"%i", registry.GetINT(".\\Results\\Size") );
	SendMessage( hwndTB, WM_SETTEXT, 0, (LPARAM)str );

	//int result = SendMessage( hwndTB, CB_ADDSTRING, 0,(LPARAM)TEXT("200") );

	// Get the size of the toolbar:
		RECT rc;
			GetWindowRect( hwndTB, &rc );

	REBARBANDINFO rbBand;
		rbBand.cbSize = sizeof(REBARBANDINFO);  // Required
		rbBand.fMask  = RBBIM_TEXT |
			             RBBIM_STYLE | RBBIM_CHILD  | RBBIM_CHILDSIZE |
				          RBBIM_SIZE;
	   rbBand.fStyle = RBBS_CHILDEDGE|RBBS_NOGRIPPER;//RBBS_VARIABLEHEIGHT|RBBS_CHILDEDGE|RBBS_NOGRIPPER|RBBS_USECHEVRON;//RBBS_GRIPPERALWAYS;//|RBBS_BREAK;//| RBBS_FIXEDBMP;
   // Set values unique to the band with the toolbar.
	   rbBand.lpText     = TEXT("Results");

		rbBand.hwndChild  = hwndTB;

		rbBand.cxMinChild = rc.right-rc.left;
		rbBand.cyMinChild = rc.bottom-rc.top;
		//rbBand.cyChild    = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		//rbBand.cyMaxChild = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		//rbBand.cyIntegral = 1; // used with RBBS_VARIABLEHEIGHT.
		
		rbBand.cx         = rbBand.cxMinChild;

   // Add the band that has the toolbar.
   SendMessage(hwndRB, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbBand);
	}//*/






//*
	{
	//////////////////////////////
	///   THE SEARCH TOOLBAR   ///
	//////////////////////////////
	// Create the toolbar control to be added.
   HWND hwndTB = CreateSearch_Toolbar_SearchGo( hwndParent );//hwndRB);
		// Get the size of the toolbar:
		SIZE size;
			SendMessage( hwndTB, TB_GETMAXSIZE, 0, (LPARAM)&size );
		//fprintf(g_flog,"   rcToolbar(w): %i\n",size.cx );
		//fprintf(g_flog,"   rcToolbar(h): %i\n",size.cy );

	REBARBANDINFO rbBand;
		rbBand.cbSize = sizeof(REBARBANDINFO);  // Required
		rbBand.fMask  = //RBBIM_TEXT |
			             RBBIM_STYLE | RBBIM_CHILD  | RBBIM_CHILDSIZE |
				          RBBIM_SIZE;
	   rbBand.fStyle = RBBS_CHILDEDGE|RBBS_NOGRIPPER;//|RBBS_VARIABLEHEIGHT|RBBS_USECHEVRON;//RBBS_GRIPPERALWAYS;//|RBBS_BREAK;//| RBBS_FIXEDBMP;
		//rbBand.hbmBack = LoadBitmap(g_hinst,MAKEINTRESOURCE(IDB_BACKGRND));  
   // Set values unique to the band with the toolbar.
	   //rbBand.lpText     = TEXT("Search Go");
				
		rbBand.hwndChild  = hwndTB;
		
		rbBand.cxMinChild = size.cx;
		rbBand.cyMinChild = size.cy;
		//rbBand.cyChild    = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		//rbBand.cyMaxChild = rbBand.cyMinChild; // used with RBBS_VARIABLEHEIGHT.
		//rbBand.cyIntegral = 1; // used with RBBS_VARIABLEHEIGHT.
		
		rbBand.cx         = size.cx;

		// Add the band that has the toolbar.
		int result = SendMessage( hwndRB, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbBand );
	}//*/





	AddTextToReBar( hwndRB, L"JLookUp 2004\0" );
/*
	{
	// Initialize structure members that both bands will share.
   REBARBANDINFO rbBand;
		rbBand.cbSize = sizeof(REBARBANDINFO);  // Required
		rbBand.fMask  = RBBIM_COLORS | RBBIM_TEXT |
			             RBBIM_STYLE;// | RBBIM_SIZE;
	   rbBand.fStyle = RBBS_NOGRIPPER;//RBBS_GRIPPERALWAYS;//|RBBS_BREAK;//| RBBS_FIXEDBMP;
   // Set values unique to the band with the toolbar.
		rbBand.clrFore    = 0;
		rbBand.clrBack    = GetSysColor(COLOR_MENU);

		//rbBand.lpText     = TEXT("JQuickTrans is all >_<.");
		rbBand.lpText     = TEXT("JLookUp 2004");
		
		//rbBand.cx         = 100;

   // Add the band that has the toolbar.
   SendMessage(hwndRB, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbBand);
	//SendMessage(hwndRB, RB_INSERTBAND, (WPARAM)8, (LPARAM)&rbBand);
	}//*/


	//SetWindowPos( hwndRB,0, 0,0, 0,0, 0 );

	//fprintf(g_flog,"END CreateSearch_Rebar()\n");
	return( hwndRB );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////

