// Window_About.h | by Doug Manley (2004.07.04)
///////////////////////////////////////////////////////////
#ifndef WINDOW_ABOUT_H
#define WINDOW_ABOUT_H
///////////////////////////////////////////////////////////
bool window_about_open;
///////////////////////////////////////////////////////////
Rect rc_about_top, rc_about_bottom;
Bitmap *img_about_logo;
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
LRESULT CALLBACK WndProc_Window_About( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) {
	static HWND hwnd_button_ok = NULL;

	static RectF rclink_jlookup(0,0,0,0);
	static RectF rclink_aumaan(0,0,0,0);
	static RectF rclink_email(0,0,0,0);

	switch( message ) {
		case WM_CREATE: {
			window_about_open = true;

			RECT rcClient;
				GetClientRect( hWnd, &rcClient );

			int w = 70, h = 26;
			hwnd_button_ok = CreateWindowEx(
				0,
				L"BUTTON", L"Okay",
				WS_CHILD | BS_PUSHBUTTON,
				0,0,
				w,h,
				hWnd,
				NULL,
				g_hinst,
				NULL
			);

			HFONT hfont_button = CreateFont(14, 0,0,0,0,0,0,0,0,0,0,0,0,ToWString(".\\Search\\Font\\Font").c_str() );
			SendMessage( hwnd_button_ok, WM_SETFONT, (WPARAM)hfont_button,TRUE );

			int x = (rcClient.right-rcClient.left)/2-w/2, y = rcClient.bottom-h-h;
			SetWindowPos( hwnd_button_ok, NULL,	x,y, 0,0, SWP_NOZORDER|SWP_NOSIZE|SWP_SHOWWINDOW );


			rc_about_top.X = 0;
			rc_about_top.Y = 0;
			rc_about_top.Width = (rcClient.right-rcClient.left);
			rc_about_top.Height = (rcClient.bottom-rcClient.top)-h-h-h;

			rc_about_bottom.X = 0;
			rc_about_bottom.Y = y-h;
			rc_about_bottom.Width = (rcClient.right-rcClient.left);
			rc_about_bottom.Height = h+h+h;

			img_about_logo = Bitmap::FromResource( g_hinst, MAKEINTRESOURCE(IDB_LOGO) );
			return(0);
		}
		case WM_PAINT: {
			HDC hdc;
			PAINTSTRUCT ps;
			hdc = BeginPaint(hWnd, &ps);
				Graphics graphics(hdc);
				RECT rcClient;
					GetClientRect( hWnd, &rcClient );

					SolidBrush brush_text( Color( 0,0,0 ) );
					SolidBrush brush_link( Color( 0,0,255 ) );
					SolidBrush brush_bottom( Color( 196,196,196 ) );

					Font font_title( L"Arial.ttf", 12, FontStyleBold );
					Font font_text( L"Arial.ttf", 12, FontStyleRegular );

					int x = rc_about_top.Width/2-img_about_logo->GetWidth()/2, y = 6;

					///////////////////
					///   THE TOP   ///
					///////////////////
					graphics.DrawImage(
						img_about_logo,
						x,y
					);
					y += img_about_logo->GetHeight();

					x = 10;

					Uint16 str[1024];
					RectF rcsize;


					// Title:
					swprintf(str,L"JLookUp");
						graphics.MeasureString( str,wcslen(str), &font_title, PointF( x,y ), &rcsize );						
						graphics.DrawString(    str,wcslen(str), &font_title, PointF( x,y ), &brush_text );
					y += rcsize.Height;

					// Indent:
					x += 30;
						swprintf(str,L"Version: %s",version_info);
							graphics.MeasureString( str,wcslen(str), &font_text, PointF( x,y ), &rcsize );						
							graphics.DrawString(    str,wcslen(str), &font_text, PointF( x,y ), &brush_text );
						y += rcsize.Height;

						swprintf(str,L"Homepage: ");
							graphics.MeasureString( str,wcslen(str), &font_text, PointF( x,y ), &rcsize );						
							graphics.DrawString(    str,wcslen(str), &font_text, PointF( x,y ), &brush_text );
						swprintf(str,L"http://jlookup.aumaan.no-ip.org");
							graphics.MeasureString( str,wcslen(str), &font_text, PointF( x+rcsize.Width,y ), &rclink_jlookup );						
							graphics.DrawString(    str,wcslen(str), &font_text, PointF( x+rcsize.Width,y ), &brush_link );
						y += rcsize.Height;

					// Title:
					x -= 30;
					y += 12;
					swprintf(str,L"Made by Doug Manley");
						graphics.MeasureString( str,wcslen(str), &font_title, PointF( x,y ), &rcsize );						
						graphics.DrawString(    str,wcslen(str), &font_title, PointF( x,y ), &brush_text );
					y += rcsize.Height;

					// Indent:
					x += 30;
						swprintf(str,L"Web site: ");
							graphics.MeasureString( str,wcslen(str), &font_text, PointF( x,y ), &rcsize );						
							graphics.DrawString(    str,wcslen(str), &font_text, PointF( x,y ), &brush_text );
						swprintf(str,L"http://aumaan.no-ip.org");
							graphics.MeasureString( str,wcslen(str), &font_text, PointF( x+rcsize.Width,y ), &rclink_aumaan );						
							graphics.DrawString(    str,wcslen(str), &font_text, PointF( x+rcsize.Width,y ), &brush_link );
						y += rcsize.Height;

						swprintf(str,L"Contact: ");
							graphics.MeasureString( str,wcslen(str), &font_text, PointF( x,y ), &rcsize );						
							graphics.DrawString(    str,wcslen(str), &font_text, PointF( x,y ), &brush_text );
						swprintf(str,L"ssvegeta7@yahoo.com");
							graphics.MeasureString( str,wcslen(str), &font_text, PointF( x+rcsize.Width,y ), &rclink_email );						
							graphics.DrawString(    str,wcslen(str), &font_text, PointF( x+rcsize.Width,y ), &brush_link );
						y += rcsize.Height;


					//////////////////////
					///   THE BOTTOM   ///
					//////////////////////
					graphics.FillRectangle( &brush_bottom, rc_about_bottom );

			EndPaint(hWnd, &ps);
			return(0);
		}//*/
		case WM_COMMAND: {
		/* wParam
				The high-order word specifies the notification code if the message is from a control. If the message is from an accelerator, this value is 1. If the message is from a menu, this value is zero. 
				The low-order word specifies the identifier of the menu item, control, or accelerator. 

			lParam
				Handle to the control sending the message if the message is from a control. Otherwise, this parameter is NULL. 
		*/
			if( lParam == (LPARAM)hwnd_button_ok ) {
				switch( HIWORD(wParam) ) {
					case BN_CLICKED: {
						SendMessage( hWnd,WM_CLOSE, 0,0 );
						break;
					}
				}
			}
			return(0);
		}
		case WM_LBUTTONDOWN: {
			SHORT mx = LOWORD(lParam), my = HIWORD(lParam);

			if( rclink_jlookup.Contains( PointF(mx,my) ) ) {
				ShellExecute( NULL, L"open", L"http://jlookup.aumaan.no-ip.org", NULL,NULL, SW_SHOW );
			} else if( rclink_aumaan.Contains( PointF(mx,my) ) ) {
				ShellExecute( NULL, L"open", L"http://aumaan.no-ip.org", NULL,NULL, SW_SHOW );
			} else if( rclink_email.Contains( PointF(mx,my) ) ) {
				ShellExecute( NULL, L"open", L"mailto:ssvegeta7@yahoo.com", NULL,NULL, SW_SHOW );
			}

			return(0);
		}
		case WM_MOUSEMOVE: {
			SHORT mx = LOWORD(lParam), my = HIWORD(lParam);

			// Set the cursor to the standard arrow:
			SetCursor( cursor_arrow );

			// If the mouse moves over the window, capture it:
			HWND hwnd_focus = GetFocus();
			if( hwnd_focus != hWnd ) {
				HWND hwnd_old = SetFocus( hWnd );
				if( hwnd_old == NULL ) {
					fwprintf(g_flogu,L"ResultWindow: WM_MOUSEMOVE:\n   SetFocus(): ERROR: %u\n",GetLastError() );
				}
			}

			if( rclink_jlookup.Contains( PointF(mx,my) ) ||
				 rclink_aumaan.Contains( PointF(mx,my) ) ||
				 rclink_email.Contains( PointF(mx,my) ) ) {
				SetCursor( cursor_hand );
			} else {
				SetCursor( cursor_arrow );
			}

			return(0);
		}
		case WM_KEYDOWN: {
			switch (wParam) {
				case VK_ESCAPE: {
					SendMessage( hWnd,WM_CLOSE, 0,0 );
					break;
				}
			}
			return(0);
		}// case WM_KEYDOWN
		case WM_DESTROY: {
			window_about_open = false;
			delete img_about_logo;
			return(0);
		}
	}
	return( DefWindowProc(hWnd, message, wParam, lParam) );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateWindow_About( HWND hwndParent, int x,int y, int w,int h ) {
	WNDCLASS wndClass; 
		//wndClass.style          = CS_SAVEBITS; //CS_HREDRAW | CS_VREDRAW;
		wndClass.style          = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
		wndClass.lpfnWndProc    = WndProc_Window_About;
		wndClass.cbClsExtra     = 0;
		wndClass.cbWndExtra     = 0;
		wndClass.hInstance      = g_hinst;
		wndClass.hIcon          = LoadIcon( g_hinst,MAKEINTRESOURCE(IDI_PROGRAM) );//LoadIcon(NULL, IDI_APPLICATION);
		wndClass.hCursor        = NULL;//LoadCursor(NULL, IDC_ARROW);
		wndClass.hbrBackground  = (HBRUSH)GetStockObject(WHITE_BRUSH);
	   wndClass.lpszMenuName   = NULL;
		wndClass.lpszClassName  = TEXT("Class_About");
   
	RegisterClass(&wndClass);

	HWND hWnd = CreateWindowEx(
		WS_EX_CLIENTEDGE,
		L"Class_About",
		L"About JLookUp",
		WS_SYSMENU|WS_CAPTION,
		x,y,
		w,h,
		hwndParent,
		NULL,
		g_hinst,
		NULL
	);

	//ShowWindow( hWnd,SW_SHOW );
	return( hWnd );
}
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
