// Window_Thread.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef WINDOW_THREAD_H
#define WINDOW_THREAD_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND hwnd_searching = NULL;
wstring searching_text;
bool show_escape;
LRESULT CALLBACK WndProc_Searching_Window( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) {
   switch( message ) {
		case WM_CREATE: {
			return(0);
		}
		case WM_SIZE: {
			return( 0 );
		}
		case WM_PAINT: {
			HDC hdc;
			PAINTSTRUCT ps;
			hdc = BeginPaint(hWnd, &ps);
			   Graphics graphics(hdc);

				RECT rcClient;
					GetClientRect( hWnd, &rcClient );

				{
					SolidBrush brush_bg( Color(128,128,128) );

					RectF rcFill;
						rcFill.X = rcClient.left;
						rcFill.Y = rcClient.top;
						rcFill.Width = rcClient.right;
						rcFill.Height = rcClient.bottom;
					graphics.FillRectangle( &brush_bg, rcFill );
				}

				rcClient.left += 2; rcClient.top += 2;
				rcClient.right -= 4; rcClient.bottom -= 4;

				{
					SolidBrush brush_bg( Color(196,196,196) );

					RectF rcFill;
						rcFill.X = rcClient.left;
						rcFill.Y = rcClient.top;
						rcFill.Width = rcClient.right;
						rcFill.Height = rcClient.bottom;
					graphics.FillRectangle( &brush_bg, rcFill );
				}

				Font font_text( L"Arial",20 );
				Font font_text2( L"Arial",14 );
				SolidBrush brush_text( Color(0,0,0) );

				StringFormat format(0);
					format.SetTrimming( StringTrimmingNone );

				SizeF sizef( rcClient.right,rcClient.bottom );
				SizeF stringsizef;
				graphics.MeasureString( searching_text.c_str(), searching_text.size(), &font_text,
					sizef,
					&format,
					&stringsizef
				);

				int x = rcClient.right/2-stringsizef.Width/2;
				int y = rcClient.bottom/2-stringsizef.Height/2;
				graphics.DrawString( searching_text.c_str(), searching_text.size(), &font_text,
					PointF( x,y ),
					&format,
					&brush_text
				);

				y += stringsizef.Height;

				if( show_escape ) {
					wstring text = L"(Press ESC to stop)";
					graphics.MeasureString( text.c_str(), text.size(), &font_text2,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString( text.c_str(), text.size(), &font_text2,
						PointF( rcClient.right/2-stringsizef.Width/2, y ),
						&format,
						&brush_text
					);
				}

			EndPaint(hWnd, &ps);
			return(0); // An application should return 0 if it processes WM_PAINT.
		}
		case WM_ERASEBKGND: {
			// An application should return 0 if it did NOT erase the backgound.
			// Here, we're faking that we did, so...
			return(TRUE);
		}
   }
   return( DefWindowProc(hWnd, message, wParam, lParam) );
} // WndProc
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
void CreateThreadWindow( wstring text, bool escape=true ) {
	static bool firsttime = true;
	if( firsttime ) {
		WNDCLASS wndClass;
			wndClass.style          = CS_HREDRAW | CS_VREDRAW;
			wndClass.lpfnWndProc    = WndProc_Searching_Window;
		   wndClass.cbClsExtra     = 0;
			wndClass.cbWndExtra     = 0;
		   wndClass.hInstance      = g_hinst;
			wndClass.hIcon          = NULL;
			wndClass.hCursor        = NULL;//LoadCursor(NULL, IDC_ARROW);
			wndClass.hbrBackground  = (HBRUSH)GetStockObject(LTGRAY_BRUSH); //GetSysColorBrush(COLOR_MENU);
		   wndClass.lpszMenuName   = NULL;
			wndClass.lpszClassName  = TEXT("Searching");
   
		if( RegisterClass(&wndClass) == 0 ) {
			MessageBox(NULL,L"Error registering window class.",L"Error",MB_OK );
			exit(-1);
		}
		firsttime = false;
	}

	show_escape = escape;
	searching_text = text;

	HWND hwndold = GetCapture();

	int w = 300, h = 150;   
   HWND hwnd = CreateWindowEx(
		0,//WS_EX_TOPMOST,
      TEXT("Searching"), // window class name
		L"WindowTitle", // Window title
		WS_POPUP, // window style
      0,0,
		w,h,
      hwnd_mainwindow, // parent window handle
      NULL, // window menu handle
      g_hinst, // program instance handle
      NULL // creation parameters
	);
	if( hwnd == NULL ) {
		MessageBox(NULL,L"hwnd_searching not made!",L"Error",MB_OK );
	}

	SetCapture(hwndold);

	RECT rcClient;
		GetClientRect(hwnd_mainwindow,&rcClient );
	RECT rcWindow;
		GetWindowRect(hwnd_mainwindow,&rcWindow );
	int x = rcWindow.left + rcClient.right/2-w/2;
	int y = rcWindow.top + rcClient.bottom/2-h/2;
	//x = 0; y = 0;
	SetWindowPos(hwnd,NULL,x,y,0,0,SWP_NOACTIVATE|SWP_SHOWWINDOW|SWP_NOZORDER|SWP_NOSIZE);

	//fwprintf(g_flogu,L"hwnd_searching: %i,%i, %i,%i\n",x,y,w,h );

	hwnd_searching = hwnd;
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////