// Window_Update.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef WINDOW_UPDATE_H
#define WINDOW_UPDATE_H
///////////////////////////////////////////////////////////
HWND hwnd_update;
HWND hwnd_update_status;
HWND hwnd_update_edit;
	const int WID_UPDATE_EDIT = 2101;
HWND hwnd_update_files;
	const int WID_UPDATE_FILES = 2102;
HWND hwnd_update_btn_cancel;
HWND hwnd_update_btn_site;
HWND hwnd_update_btn_get;
///////////////////////////////////////////////////////////
#include "Update_Thread.h"
///////////////////////////////////////////////////////////
LRESULT CALLBACK WndProc_Window_Update( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) {
	static int edit_buffer = 5;
	static int edit_start = 25;
	static int edit_h = 370;
	static int files_start = edit_start+edit_h+edit_start;
	static int files_h = 100;
   switch( message ) {
		case WM_CREATE: {
			RECT rc;
				GetClientRect( hWnd, &rc );

			// Make the status bar at the bottom:
			hwnd_update_status = CreateWindowEx( 
		      0L, // no extended styles
		      STATUSCLASSNAME, // status bar
	         TEXT(""), // text 
				WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS, // styles
				rc.bottom-10,0, // (x,y)
				rc.right,10, // (w,h)
			   hWnd, // parent window
		      (HMENU)100, // window ID
	         g_hinst, // instance
				NULL // window data
			);

			// Get the rectangle for the status bar at the bottom:
			RECT rcStatus;
				GetWindowRect( hwnd_update_status, &rcStatus );

			// Resize the client area to account for the status window:
			rc.bottom -= (rcStatus.bottom - rcStatus.top)+1;



			hwnd_update_edit = CreateWindowEx(
				WS_EX_CLIENTEDGE,
				RICHEDIT_CLASS, NULL,
            WS_CHILD | WS_VISIBLE | WS_BORDER | WS_VSCROLL | 
            ES_LEFT | ES_MULTILINE | ES_READONLY,
            0,0, 0,0,
            hWnd,
            (HMENU)WID_UPDATE_EDIT,
            (HINSTANCE)g_hinst, 
            NULL
			);
			SetWindowPos( hwnd_update_edit, 0, 0+edit_buffer,edit_start, rc.right-2*edit_buffer,edit_h, SWP_NOZORDER|SWP_SHOWWINDOW );
			// Set the margins:
			SendMessage( hwnd_update_edit, EM_SETMARGINS, EC_LEFTMARGIN,2 );

			// Basically, set the font and stuff:
			CHARFORMAT2 charformat;
				charformat.cbSize = sizeof(CHARFORMAT2);
				charformat.dwEffects = 0;
				charformat.bPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
				charformat.dwMask = CFM_FACE | CFM_CHARSET | CFM_WEIGHT;
				// CFM_FACE:
				wcscpy(charformat.szFaceName, ToWString( registry.GetSTRING(".\\Search\\Font\\Font") ).c_str() );
				// CFM_CHARSET:
				charformat.bCharSet = DEFAULT_CHARSET;//SHIFTJIS_CHARSET;//DEFAULT_CHARSET;
				// CFM_WEIGHT:
				charformat.wWeight = FW_REGULAR;
			SendMessage( hwnd_update_edit, EM_SETCHARFORMAT, (WPARAM)SCF_ALL, (LPARAM)&charformat );








			hwnd_update_files = CreateWindowEx(
				WS_EX_CLIENTEDGE,
				RICHEDIT_CLASS, NULL,
            WS_CHILD | WS_VISIBLE | WS_BORDER | WS_VSCROLL | 
            ES_LEFT | ES_MULTILINE | ES_READONLY,
            0,0, 0,0,
            hWnd,
            (HMENU)WID_UPDATE_FILES,
            (HINSTANCE)g_hinst, 
            NULL
			);
			SetWindowPos( hwnd_update_files, 0, 0+edit_buffer,files_start, rc.right-2*edit_buffer,files_h, SWP_NOZORDER|SWP_SHOWWINDOW );
			// Set the margins:
			SendMessage( hwnd_update_files, EM_SETMARGINS, EC_LEFTMARGIN,2 );

			SendMessage( hwnd_update_files, EM_SETCHARFORMAT, (WPARAM)SCF_ALL, (LPARAM)&charformat );





			HFONT hfont_button = CreateFont(14, 0,0,0,0,0,0,0,0,0,0,0,0,ToWString(".\\Search\\Font\\Font").c_str() );
			int x = 0+edit_buffer, y = 0+files_start+files_h+4;
			int w = 150;
			int h = 24;

			hwnd_update_btn_cancel = CreateWindowEx(
				0,
				L"BUTTON", L"Cancel",
				WS_CHILD | BS_PUSHBUTTON,
				x, y,
				w,h,
				hWnd,
				NULL,
				g_hinst,
				NULL
			);
			SendMessage( hwnd_update_btn_cancel, WM_SETFONT, (WPARAM)hfont_button,TRUE );
			ShowWindow( hwnd_update_btn_cancel, SW_SHOW );


			hwnd_update_btn_site = CreateWindowEx(
				0,
				L"BUTTON", L"Check out the site",
				WS_CHILD | BS_PUSHBUTTON,
				rc.right/2-w/2,y,
				w,h,
				hWnd,
				NULL,
				g_hinst,
				NULL
			);
			SendMessage( hwnd_update_btn_site, WM_SETFONT, (WPARAM)hfont_button,TRUE );
			ShowWindow( hwnd_update_btn_site, SW_SHOW );


			hwnd_update_btn_get = CreateWindowEx(
				0,
				L"BUTTON", L"Get files",
				WS_CHILD | BS_PUSHBUTTON,
				rc.right-x-w,y,
				w,h,
				hWnd,
				NULL,
				g_hinst,
				NULL
			);
			SendMessage( hwnd_update_btn_get, WM_SETFONT, (WPARAM)hfont_button,TRUE );
			ShowWindow( hwnd_update_btn_get, SW_SHOW );





			return(0);
		}
		case WM_SIZE: {
			// These values apply to the CLIENT AREA:
			int neww = LOWORD(lParam);
			int newh = HIWORD(lParam);

			// Fix the status window automatically:
			SendMessage( hwnd_update_status, WM_SIZE, wParam,lParam );

			// Get the modified sizes:
			RECT rcStatus;
				GetWindowRect( hwnd_update_status, &rcStatus );
			newh -= (rcStatus.bottom - rcStatus.top)+1;
			return(0);
		}
		case WM_PAINT: {
			HDC hdc;
			PAINTSTRUCT ps;
	      hdc = BeginPaint(hWnd, &ps);
			Graphics graphics(hdc);

				Font font_text( ToWString(registry.GetSTRING(".\\Search\\Font\\Font")).c_str(), 10 );
			
				SolidBrush brush_text( Color(0,0,0) );

				StringFormat format(0);//(StringFormatFlagsNoWrap);
					format.SetTrimming( StringTrimmingNone );

				int word_width = 0;
				int word_height = 0;
				
				SizeF stringsizef;
				SizeF sizef( 600,600 );
				wstring text = L"The following updates apply to this version:";
				graphics.MeasureString( text.c_str(), text.size(), &font_text,
					sizef,
					&format,
					&stringsizef
				);

				graphics.DrawString( text.c_str(), text.size(),	&font_text,
					PointF( 0+edit_buffer, 0+edit_buffer ),
					&format,
					&brush_text
				);



				text = L"The following files will be downloaded:";
				graphics.MeasureString( text.c_str(), text.size(), &font_text,
					sizef,
					&format,
					&stringsizef
				);

				graphics.DrawString( text.c_str(), text.size(),	&font_text,
					PointF( 0+edit_buffer, 0+files_start-edit_start+edit_buffer ),
					&format,
					&brush_text
				);

		   EndPaint(hWnd, &ps);
			return(0); // An application should return 0 if it processes WM_PAINT.
		}//*/
		case WM_COMMAND: {
		/* wParam
				The high-order word specifies the notification code if the message is from a control. If the message is from an accelerator, this value is 1. If the message is from a menu, this value is zero. 
				The low-order word specifies the identifier of the menu item, control, or accelerator. 

			lParam
				Handle to the control sending the message if the message is from a control. Otherwise, this parameter is NULL. 
		*/
			if( lParam == (LPARAM)hwnd_update_btn_cancel ) {
				switch( HIWORD(wParam) ) {
					case BN_CLICKED: {
						if( thread_updating ) {  break;  }
						SendMessage( hWnd,WM_CLOSE, 0,0 );
						break;
					}
				}
			} else if( lParam == (LPARAM)hwnd_update_btn_site ) {
				switch( HIWORD(wParam) ) {
					case BN_CLICKED: {
						ShellExecute( NULL, L"open", L"http://jlookup.aumaan.no-ip.org", NULL,NULL, SW_SHOW );
						break;
					}
				}
			} else if( lParam == (LPARAM)hwnd_update_btn_get ) {
				switch( HIWORD(wParam) ) {
					case BN_CLICKED: {
						// Get the files:
						if( thread_updating ) {  break;  }
						if( get_files.size() == 0 ) {  break;  }


						//////////////////////////////////
						///   GET THE UPDATES ONLINE   ///
						//////////////////////////////////
						// Thread time:
						HANDLE hthread = Load_Thread_GetUpdates();
						enum {  UPDATE_ABORT, UPDATE_DONE, UPDATE_QUIT  };
						int wtf = -1;
						MSG msg;
						while( true ) {
							if( !thread_updating ) {  wtf = UPDATE_DONE;  break;  }
							// Check to see if we have an ESCAPE key message.
							PeekMessage( &msg, NULL, 0,0, PM_REMOVE );
							TranslateMessage(&msg);
							if( msg.message == WM_KEYDOWN && msg.wParam == VK_ESCAPE ) {  wtf = UPDATE_ABORT;  break;  }
							if( msg.message == WM_QUIT ) {  wtf = UPDATE_QUIT;  break;  }
							DispatchMessage(&msg);

							Sleep( 10L );
						}
						if( wtf != UPDATE_DONE ) {
							////////////////////////////////
							///   UPDATE CHECK ABORTED   ///
							////////////////////////////////
							TerminateThread( hthread, 0L );
							CloseHandle(hthread);
							thread_updating = false;

							// Kill the window:
							SendMessage(hWnd,WM_CLOSE,0,0 );

							if( wtf == UPDATE_QUIT ) {
								// Close the program:
								SendMessage(hwnd_mainwindow,WM_QUIT,0,0);
							}
							// All done here:
							break;
						} else {
							CloseHandle(hthread);
						}



						bool allokay = thread_getupdates_exitcode;

						if( allokay ) {
							SendMessage(hwnd_update_status,WM_SETTEXT,0,(LPARAM)L"All files downloaded OKAY!" );

							FILE *file = fopen("Updates.jlf","at");
							if( file ) {
								fprintf(file,"%s\n",get_id.c_str() );
								fclose(file);
							} else {
								MessageBox(NULL,L"Couldn't open Updates.jlf to log the update.",L"Error",MB_OK );
							}

							MessageBox(NULL,L"The updates have been downloaded.\n\nPlease do whatever the instructions said to avoid problems ^_^",L"Updates complete",MB_OK );
							SendMessage(hWnd,WM_CLOSE,0,0);
						} else {
							SendMessage(hwnd_update_status,WM_SETTEXT,0,(LPARAM)L"At least one file failed." );
						}
						break;
					}
				}
			}
			return(0);
		}
		case WM_MOUSEMOVE: {
			int mx = LOWORD(lParam), my = HIWORD(lParam);
			return(0);
		}
		case WM_LBUTTONDOWN: {
			int mx = LOWORD(lParam), my = HIWORD(lParam);
			return(0);
		}
		case WM_LBUTTONUP: {
			int x = LOWORD(lParam), y = HIWORD(lParam);
			return(0);
		}
		case WM_CLOSE: {
			DestroyWindow( hwnd_update );
				hwnd_update = NULL;
			DestroyWindow( hwnd_update_status );
				hwnd_update_status = NULL;
			DestroyWindow( hwnd_update_edit );
				hwnd_update_edit = NULL;
			DestroyWindow( hwnd_update_files );
				hwnd_update_files = NULL;
			DestroyWindow( hwnd_update_btn_cancel );
				hwnd_update_btn_cancel = NULL;
			DestroyWindow( hwnd_update_btn_site );
				hwnd_update_btn_site = NULL;
			DestroyWindow( hwnd_update_btn_get );
				hwnd_update_btn_get = NULL;
         return(0); // ~"yatta!"
      }
   }
   return( DefWindowProc(hWnd, message, wParam, lParam) );
} // WndProc
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateWindow_Update( HWND hwndParent, int x,int y, int w,int h, int show = SW_SHOW ) {
	static bool firsttime = true;
	if( firsttime ) {
	   WNDCLASS wndClass;
		   wndClass.style          = CS_HREDRAW | CS_VREDRAW; //CS_SAVEBITS;
			wndClass.lpfnWndProc    = WndProc_Window_Update;
		   wndClass.cbClsExtra     = 0;
			wndClass.cbWndExtra     = 0;
			wndClass.hInstance      = g_hinst;
			wndClass.hIcon          = LoadIcon( g_hinst,MAKEINTRESOURCE(IDI_PROGRAM) ); //LoadIcon(NULL, IDI_APPLICATION);
		   wndClass.hCursor        = NULL;//LoadCursor(NULL, IDC_ARROW);
			wndClass.hbrBackground  = GetSysColorBrush(COLOR_MENU);
		   wndClass.lpszMenuName   = NULL;
			wndClass.lpszClassName  = TEXT("JLookUp_Update");
   
		if( RegisterClass(&wndClass) == 0 ) {
			MessageBox(NULL,L"Error registering window class.",L"Error",MB_OK );
			exit(-1);
		}
		firsttime = false;
	}

   HWND hWnd = CreateWindowEx(
		0,
      TEXT("JLookUp_Update"), // window class name
		TEXT("JLookUp Updater"), // Window title
      //WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN, // window style
		WS_BORDER | WS_CAPTION | WS_SYSMENU | WS_CLIPCHILDREN,
      x,y,
		w,h,
      hwndParent, // parent window handle
      NULL, // window menu handle
      g_hinst, // program instance handle
      NULL // creation parameters
	);

	if( !hWnd ) {
		MessageBox(NULL,L"Error opening the update window.",L"Error",MB_OK );
		exit(-1);
	}
	  
   ShowWindow( hWnd, show );
	return(hWnd);
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////